function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import ChevronIkon from '@sb1/ffe-icons-react/lib/chevron-ikon';
import classNames from 'classnames';
import PropTypes from 'prop-types';
import React, { Component } from 'react';
import { polyfill } from 'react-lifecycles-compat';
import shallowEqual from 'shallow-equals';
import TableRow from './TableRow';

var TableRowExpandable =
/*#__PURE__*/
function (_Component) {
  _inherits(TableRowExpandable, _Component);

  function TableRowExpandable(props) {
    var _this;

    _classCallCheck(this, TableRowExpandable);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TableRowExpandable).call(this, props));
    _this.handleKeyPress = _this.handleKeyPress.bind(_assertThisInitialized(_this));
    _this.toggleExpand = _this.toggleExpand.bind(_assertThisInitialized(_this));
    _this.state = {
      expanded: false,
      sort: props.sort
    };
    return _this;
  }

  _createClass(TableRowExpandable, [{
    key: "toggleExpand",
    value: function toggleExpand() {
      this.setState(function (prevState) {
        return {
          expanded: !prevState.expanded
        };
      });
    }
  }, {
    key: "handleKeyPress",
    value: function handleKeyPress(event) {
      if ((event.key === 'Enter' || event.key === ' ') && event.target.tagName === 'TR') {
        this.setState(function (prevState) {
          return {
            expanded: !prevState.expanded
          };
        });
        event.preventDefault();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          cells = _this$props.cells,
          columns = _this$props.columns,
          children = _this$props.children,
          rowRender = _this$props.rowRender,
          rowIndex = _this$props.rowIndex;
      var unexpandable = !children;
      return React.createElement("tbody", null, React.createElement(TableRow, {
        cells: _objectSpread({}, cells, {
          expandIcon: unexpandable ? ' ' : React.createElement(ChevronIkon, {
            className: classNames('ffe-table__expand-icon', {
              'ffe-table__expand-icon--expanded': this.state.expanded
            })
          })
        }),
        trClasses: classNames({
          'ffe-table__row-expandable': !unexpandable
        }, {
          'ffe-table__row-expandable--expanded': this.state.expanded
        }),
        columns: columns,
        onClick: this.toggleExpand,
        onKeyDown: this.handleKeyPress,
        expandable: !unexpandable,
        expanded: this.state.expanded,
        rowRender: rowRender,
        rowIndex: rowIndex
      }), React.createElement("tr", {
        role: "presentation",
        "aria-hidden": String(!this.state.expanded),
        className: classNames('ffe-table__row', 'ffe-table__row-expandable-content', {
          'ffe-table__row-expandable-content--expanded': this.state.expanded
        }, {
          'ffe-table__row--collapsed': !this.state.expanded
        })
      }, React.createElement("td", {
        colSpan: columns.length,
        className: "ffe-table__cell-expandable-content"
      }, React.createElement("div", null, this.state.expanded && children))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (!nextProps.children && prevState.expanded || !shallowEqual(nextProps.sort, prevState.sort)) {
        return {
          expanded: false,
          sort: nextProps.sort
        };
      }

      return null;
    }
  }]);

  return TableRowExpandable;
}(Component);

TableRowExpandable.propTypes = {
  children: PropTypes.node,
  cells: PropTypes.object.isRequired,
  columns: PropTypes.array.isRequired,
  sort: PropTypes.object,
  rowRender: PropTypes.func,
  headerRender: PropTypes.func,
  footerRender: PropTypes.func,
  rowIndex: PropTypes.number
};
polyfill(TableRowExpandable);
export default TableRowExpandable;