"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _pilNedIkon = _interopRequireDefault(require("@sb1/ffe-icons-react/lib/pil-ned-ikon"));

var _classnames = _interopRequireDefault(require("classnames"));

var _deepEqual = _interopRequireDefault(require("deep-equal"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _Table = _interopRequireDefault(require("../Table"));

var _sortData = _interopRequireDefault(require("./sort-data"));

var _memoizeOne = _interopRequireDefault(require("memoize-one"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SortableTable =
/*#__PURE__*/
function (_Component) {
  _inherits(SortableTable, _Component);

  function SortableTable(props) {
    var _this;

    _classCallCheck(this, SortableTable);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SortableTable).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "sortTableData", (0, _memoizeOne.default)(function (columns, data, sortBy, descending) {
      return sortBy ? (0, _sortData.default)(columns, data, sortBy, descending) : data;
    }));

    var _sortBy = props.sortBy,
        _descending = props.descending;
    _this.state = {
      sortBy: _sortBy,
      descending: _descending
    };
    return _this;
  }

  _createClass(SortableTable, [{
    key: "sortStateHasChanged",
    value: function sortStateHasChanged(nextState) {
      return nextState.sortBy !== this.state.sortBy || nextState.descending !== this.state.descending;
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !(0, _deepEqual.default)(nextProps, this.props) || this.sortStateHasChanged(nextState);
    }
  }, {
    key: "tableHeaderClicked",
    value: function tableHeaderClicked(columnKey) {
      var _this2 = this;

      var _this$props = this.props,
          columns = _this$props.columns,
          data = _this$props.data;
      this.setState(function (prevState, currentProps) {
        var descending = columnKey === prevState.sortBy ? !prevState.descending : false;
        return {
          sortBy: columnKey,
          descending: descending
        };
      }, function () {
        return _this2.props.onSort({
          sortBy: columnKey,
          descending: _this2.state.descending,
          tableData: _this2.sortTableData(columns, data, columnKey, _this2.state.descending)
        });
      });
    }
  }, {
    key: "handleKeyPress",
    value: function handleKeyPress(columnKey, event) {
      if (event.key === 'Enter' || event.key === ' ') {
        this.tableHeaderClicked(columnKey);
        event.preventDefault();
      }
    }
  }, {
    key: "getAriaSort",
    value: function getAriaSort(column) {
      if (this.state.sortBy !== column.key) {
        return 'none';
      }

      return this.state.descending ? 'descending' : 'ascending';
    }
  }, {
    key: "decorateSortableTableHeader",
    value: function decorateSortableTableHeader(column) {
      var _this3 = this;

      if (column.header === '') {
        return _react.default.createElement("span", {
          className: "ffe-sortable-table__header"
        });
      }

      if (column.notSortable) {
        return column.header;
      }

      return _react.default.createElement("span", {
        tabIndex: "0",
        onKeyDown: function onKeyDown(event) {
          return _this3.handleKeyPress(column.key, event);
        },
        className: (0, _classnames.default)('ffe-sortable-table__header', {
          'ffe-sortable-table__header--active': this.state.sortBy === column.key
        }),
        role: "button",
        onClick: this.tableHeaderClicked.bind(this, column.key)
      }, column.header, _react.default.createElement(_pilNedIkon.default, {
        className: (0, _classnames.default)('icon', 'ffe-sortable-table__sort-arrow', {
          'ffe-sortable-table__sort-arrow--descending': this.state.sortBy === column.key && this.state.descending
        })
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var sortableColumns = this.props.columns.map(function (column) {
        return _objectSpread({}, column, {
          ariaSort: _this4.getAriaSort(column),
          header: _this4.decorateSortableTableHeader(column)
        });
      });
      var caption = this.props.caption;
      var _this$props2 = this.props,
          expandedContentMapper = _this$props2.expandedContentMapper,
          condensed = _this$props2.condensed,
          columnLayoutMobile = _this$props2.columnLayoutMobile,
          smallHeader = _this$props2.smallHeader,
          alignLeft = _this$props2.alignLeft,
          breakpoint = _this$props2.breakpoint,
          limit = _this$props2.limit,
          offset = _this$props2.offset,
          srOnlyCaption = _this$props2.srOnlyCaption,
          className = _this$props2.className,
          rowRender = _this$props2.rowRender,
          headerRender = _this$props2.headerRender,
          footerRender = _this$props2.footerRender,
          columns = _this$props2.columns,
          data = _this$props2.data;
      var _this$state = this.state,
          sortBy = _this$state.sortBy,
          descending = _this$state.descending;

      if (srOnlyCaption && sortBy) {
        caption = caption.concat(' ', sortBy, ' ', descending ? 'descending' : 'ascending');
      }

      var tableData = this.sortTableData(columns, data, sortBy, descending);
      return _react.default.createElement(_Table.default, {
        caption: caption,
        srOnlyCaption: srOnlyCaption,
        expandedContentMapper: expandedContentMapper,
        columnLayoutMobile: columnLayoutMobile,
        columns: sortableColumns,
        data: tableData,
        condensed: condensed,
        smallHeader: smallHeader,
        alignLeft: alignLeft,
        breakpoint: breakpoint,
        limit: limit,
        offset: offset,
        sort: {
          sortBy: sortBy,
          descending: descending
        },
        className: className,
        rowRender: rowRender,
        headerRender: headerRender,
        footerRender: footerRender
      });
    }
  }]);

  return SortableTable;
}(_react.Component);

SortableTable.propTypes = {
  caption: _propTypes.default.node,
  srOnlyCaption: _propTypes.default.bool,
  expandedContentMapper: _propTypes.default.func,
  offset: _propTypes.default.number,
  limit: _propTypes.default.number,
  columnLayoutMobile: _propTypes.default.bool,
  condensed: _propTypes.default.bool,
  smallHeader: _propTypes.default.bool,
  alignLeft: _propTypes.default.bool,
  breakpoint: _propTypes.default.oneOf(['sm', 'none']),
  columns: _propTypes.default.arrayOf(_propTypes.default.object).isRequired,
  data: _propTypes.default.arrayOf(_propTypes.default.object).isRequired,
  sortBy: _propTypes.default.string,
  descending: _propTypes.default.bool,
  onSort: _propTypes.default.func,
  rowRender: _propTypes.default.func,
  headerRender: _propTypes.default.func,
  footerRender: _propTypes.default.func,
  className: _propTypes.default.string
};
SortableTable.defaultProps = {
  descending: false,
  onSort: function onSort() {}
};
var _default = SortableTable;
exports.default = _default;