"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

var _default = function _default(columns, data, sortBy, descending) {
  var sortedData = _toConsumableArray(data);

  var compare = function compare(data1, data2) {
    if (!isNaN(data1[sortBy])) {
      return data1[sortBy] - data2[sortBy];
    }

    if (!data1[sortBy]) {
      return data2[sortBy] ? 1 : 0;
    }

    return data1[sortBy].localeCompare(data2[sortBy]);
  };

  var column = columns.find(function (col) {
    return col.key === sortBy;
  });
  var customCompare = column && typeof column.compare === 'function' ? column.compare : null;

  if (customCompare) {
    compare = function compare(data1, data2) {
      return customCompare(data1[sortBy], data2[sortBy]);
    };
  }

  sortedData.sort(compare);

  if (descending) {
    sortedData.reverse();
  }

  return sortedData;
};

exports.default = _default;