"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TableHeaders = _interopRequireDefault(require("../TableParts/TableHeaders"));

var _TableFooter = _interopRequireDefault(require("../TableParts/TableFooter"));

var _TableRow = _interopRequireDefault(require("../TableParts/TableRow"));

var _TableRowExpandable = _interopRequireDefault(require("../TableParts/TableRowExpandable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Table =
/*#__PURE__*/
function (_Component) {
  _inherits(Table, _Component);

  function Table() {
    _classCallCheck(this, Table);

    return _possibleConstructorReturn(this, _getPrototypeOf(Table).apply(this, arguments));
  }

  _createClass(Table, [{
    key: "renderTableCaption",
    value: function renderTableCaption() {
      var _this$props = this.props,
          caption = _this$props.caption,
          srOnlyCaption = _this$props.srOnlyCaption;

      if (!caption) {
        return null;
      }

      if (srOnlyCaption) {
        return _react.default.createElement("caption", {
          className: "ffe-screenreader-only",
          "aria-live": "polite"
        }, caption);
      }

      return _react.default.createElement("caption", {
        className: "ffe-table__caption"
      }, caption);
    }
  }, {
    key: "renderTableHeaders",
    value: function renderTableHeaders() {
      var _this$props2 = this.props,
          columns = _this$props2.columns,
          headerRender = _this$props2.headerRender;

      if (!columns.length) {
        return null;
      }

      if (this.props.expandedContentMapper) {
        columns.push({
          key: 'expandIcon',
          header: '',
          alignRight: true
        });
      }

      return _react.default.createElement(_TableHeaders.default, {
        columns: columns,
        headerRender: headerRender,
        dataWindow: this.getData()
      });
    }
  }, {
    key: "renderTableFooter",
    value: function renderTableFooter() {
      var _this$props3 = this.props,
          columns = _this$props3.columns,
          footerRender = _this$props3.footerRender;

      if (!columns.some(function (column) {
        return column.footer;
      })) {
        return null;
      }

      return _react.default.createElement(_TableFooter.default, {
        columns: columns,
        footerRender: footerRender,
        dataWindow: this.getData()
      });
    }
  }, {
    key: "getData",
    value: function getData() {
      var _this$props4 = this.props,
          data = _this$props4.data,
          offset = _this$props4.offset,
          limit = _this$props4.limit;

      if (!offset && !limit) {
        return data;
      }

      return data.slice(offset, limit ? offset + limit : data.length);
    }
  }, {
    key: "renderTableBody",
    value: function renderTableBody() {
      var _this$props5 = this.props,
          columns = _this$props5.columns,
          expandedContentMapper = _this$props5.expandedContentMapper,
          sort = _this$props5.sort,
          rowRender = _this$props5.rowRender;
      var data = this.getData();

      if (!data.length) {
        return null;
      }

      if (expandedContentMapper) {
        return data.map(function (row, index) {
          var key = row.id || row.id === 0 ? row.id.toString() : index;
          var expandedContent = expandedContentMapper(row);
          var rowProps = {
            cells: row,
            columns: columns,
            sort: sort,
            rowRender: rowRender,
            rowIndex: index
          };
          return expandedContent ? _react.default.createElement(_TableRowExpandable.default, _extends({
            key: key
          }, rowProps), expandedContent) : _react.default.createElement("tbody", {
            key: key
          }, _react.default.createElement(_TableRow.default, rowProps));
        });
      }

      return _react.default.createElement("tbody", null, data.map(function (row, index) {
        var key = row.id || row.id === 0 ? row.id.toString() : index;
        return _react.default.createElement(_TableRow.default, {
          cells: row,
          columns: columns,
          key: key,
          rowRender: rowRender,
          rowIndex: index
        });
      }));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props6 = this.props,
          alignLeft = _this$props6.alignLeft,
          condensed = _this$props6.condensed,
          smallHeader = _this$props6.smallHeader,
          columnLayoutMobile = _this$props6.columnLayoutMobile,
          breakpoint = _this$props6.breakpoint,
          className = _this$props6.className;
      return _react.default.createElement("table", {
        className: (0, _classnames.default)('ffe-table', {
          'ffe-table--condensed': condensed
        }, {
          'ffe-table--small-header': smallHeader
        }, {
          'ffe-table--columns-sm': columnLayoutMobile
        }, {
          'ffe-table--text-left': alignLeft
        }, _defineProperty({}, "ffe-table--breakpoint-".concat(breakpoint), !!breakpoint), className)
      }, this.renderTableCaption(), this.renderTableHeaders(), this.renderTableFooter(), this.renderTableBody());
    }
  }]);

  return Table;
}(_react.Component);

Table.propTypes = {
  alignLeft: _propTypes.default.bool,
  columnLayoutMobile: _propTypes.default.bool,
  caption: _propTypes.default.node,
  srOnlyCaption: _propTypes.default.bool,
  expandedContentMapper: _propTypes.default.func,
  condensed: _propTypes.default.bool,
  smallHeader: _propTypes.default.bool,
  sort: _propTypes.default.object,
  offset: _propTypes.default.number,
  limit: _propTypes.default.number,
  breakpoint: _propTypes.default.oneOf(['sm', 'none']),
  data: _propTypes.default.arrayOf(_propTypes.default.object),
  columns: _propTypes.default.arrayOf(_propTypes.default.shape({
    header: _propTypes.default.node.isRequired,
    key: _propTypes.default.string.isRequired
  }).isRequired),
  rowRender: _propTypes.default.func,
  headerRender: _propTypes.default.func,
  footerRender: _propTypes.default.func,
  className: _propTypes.default.string
};
Table.defaultProps = {
  columns: [],
  data: [],
  offset: 0,
  limit: 0
};
var _default = Table;
exports.default = _default;