"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TableCell = function TableCell(props) {
  var alignRight = props.alignRight,
      alignTop = props.alignTop,
      children = props.children,
      columnHeader = props.columnHeader,
      contentClasses = props.contentClasses,
      tdClasses = props.tdClasses;
  var dataTh = '';

  if (columnHeader) {
    if (typeof columnHeader === 'string') {
      dataTh = columnHeader;
    } else if (columnHeader.props && columnHeader.props.children) {
      dataTh = _react.default.Children.toArray(columnHeader.props.children)[0];
    }
  }

  return _react.default.createElement("td", {
    className: (0, _classnames.default)('ffe-table__cell', {
      'ffe-table__cell--top': alignTop
    }, tdClasses),
    "data-th": dataTh
  }, _react.default.createElement("span", {
    className: (0, _classnames.default)('ffe-table__content', {
      'ffe-table__content--text-right': alignRight
    }, contentClasses)
  }, children));
};

TableCell.propTypes = {
  alignRight: _propTypes.default.bool,
  alignTop: _propTypes.default.bool,
  children: _propTypes.default.any,
  columnHeader: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.node]),
  contentClasses: _propTypes.default.string,
  tdClasses: _propTypes.default.string
};
var _default = TableCell;
exports.default = _default;