"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var TableHeaders = function TableHeaders(_ref) {
  var columns = _ref.columns,
      headerRender = _ref.headerRender,
      dataWindow = _ref.dataWindow;
  var headerContent = columns.map(function (column, index) {
    if (column === null) {
      return _react.default.createElement("th", {
        key: index
      });
    }

    var thProps = {
      key: index,
      className: (0, _classnames.default)('ffe-table__heading', {
        'ffe-table--hide-sm': column.hideOnMobile
      }, {
        'ffe-table--hide-md': column.hideOnSmallTablet
      }, {
        'ffe-table--hide-lg': column.hideOnTablet
      }, {
        'ffe-table--hide-xlg': column.hideOnDesktop
      }),
      'aria-sort': column.ariaSort,
      scope: "col"
    };
    var spanProps = {
      className: (0, _classnames.default)('ffe-table__content', {
        'ffe-table__content--text-right': column.alignRight
      })
    };

    var thContentDefault = _react.default.createElement("span", spanProps, column.header);

    if (typeof column.columnHeaderRender === "function") {
      return column.columnHeaderRender(column.header, dataWindow, spanProps, thProps, columns, index);
    }

    return _react.default.createElement("th", _extends({
      key: thProps.key
    }, thProps), thContentDefault);
  });
  var trProps = {
    className: "ffe-table__row",
    children: headerContent
  };

  var trDefault = _react.default.createElement("tr", trProps);

  var headerRendered = typeof headerRender === "function" ? headerRender(trProps, columns) : trDefault;
  return _react.default.createElement("thead", {
    className: "ffe-table__head"
  }, headerRendered);
};

TableHeaders.propTypes = {
  columns: _propTypes.default.arrayOf(_propTypes.default.shape({
    alignRight: _propTypes.default.bool,
    header: _propTypes.default.node.isRequired,
    hideOnDesktop: _propTypes.default.bool,
    hideOnMobile: _propTypes.default.bool,
    hideOnSmallTablet: _propTypes.default.bool,
    hideOnTablet: _propTypes.default.bool,
    key: _propTypes.default.string.isRequired
  })),
  headerRender: _propTypes.default.func,
  dataWindow: _propTypes.default.array
};
var _default = TableHeaders;
exports.default = _default;