"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TableCell = _interopRequireDefault(require("./TableCell"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TableRow = function TableRow(props) {
  var cells = props.cells,
      columns = props.columns,
      onClick = props.onClick,
      onKeyDown = props.onKeyDown,
      trClasses = props.trClasses,
      expandable = props.expandable,
      expanded = props.expanded,
      rowRender = props.rowRender,
      rowIndex = props.rowIndex;
  var expandableProps = expandable && {
    'aria-expanded': expanded,
    onClick: onClick,
    onKeyDown: onKeyDown,
    role: 'button',
    tabIndex: '0'
  };
  var rowContent = columns.map(function (column, index) {
    return _react.default.createElement(_TableCell.default, {
      alignRight: column.alignRight,
      alignTop: column.alignTop,
      columnHeader: column.header,
      key: index,
      tdClasses: (0, _classnames.default)({
        'ffe-table__cell--collapsed': column.key === 'expandIcon'
      }, {
        'ffe-table--hide-sm': column.hideOnMobile
      }, {
        'ffe-table--hide-md': column.hideOnSmallTablet
      }, {
        'ffe-table--hide-lg': column.hideOnTablet
      }, {
        'ffe-table--hide-xlg': column.hideOnDesktop
      })
    }, column.cellRender ? column.cellRender(cells[column.key], column, props, index) : cells[column.key]);
  });

  var trprops = _objectSpread({
    className: (0, _classnames.default)('ffe-table__row', trClasses)
  }, expandableProps, {
    onClick: onClick,
    children: rowContent
  });

  if (typeof rowRender === 'function') {
    return rowRender(trprops, props, rowIndex);
  }

  return _react.default.createElement("tr", trprops, rowContent);
};

TableRow.propTypes = {
  cells: _propTypes.default.object.isRequired,
  columns: _propTypes.default.arrayOf(_propTypes.default.shape({
    alignRight: _propTypes.default.bool,
    alignTop: _propTypes.default.bool,
    header: _propTypes.default.any,
    hideOnDesktop: _propTypes.default.bool,
    hideOnMobile: _propTypes.default.bool,
    hideOnSmallTablet: _propTypes.default.bool,
    hideOnTablet: _propTypes.default.bool,
    key: _propTypes.default.string,
    cellRender: _propTypes.default.func
  })).isRequired,
  expandable: _propTypes.default.bool,
  expanded: _propTypes.default.bool,
  onClick: _propTypes.default.func,
  rowRender: _propTypes.default.func,
  headerRender: _propTypes.default.func,
  footerRender: _propTypes.default.func,
  onKeyDown: _propTypes.default.func,
  trClasses: _propTypes.default.string,
  rowIndex: _propTypes.default.number
};
var _default = TableRow;
exports.default = _default;