"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _chevronIkon = _interopRequireDefault(require("@sb1/ffe-icons-react/lib/chevron-ikon"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _reactLifecyclesCompat = require("react-lifecycles-compat");

var _shallowEquals = _interopRequireDefault(require("shallow-equals"));

var _TableRow = _interopRequireDefault(require("./TableRow"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var TableRowExpandable =
/*#__PURE__*/
function (_Component) {
  _inherits(TableRowExpandable, _Component);

  function TableRowExpandable(props) {
    var _this;

    _classCallCheck(this, TableRowExpandable);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TableRowExpandable).call(this, props));
    _this.handleKeyPress = _this.handleKeyPress.bind(_assertThisInitialized(_this));
    _this.toggleExpand = _this.toggleExpand.bind(_assertThisInitialized(_this));
    _this.state = {
      expanded: false,
      sort: props.sort
    };
    return _this;
  }

  _createClass(TableRowExpandable, [{
    key: "toggleExpand",
    value: function toggleExpand() {
      this.setState(function (prevState) {
        return {
          expanded: !prevState.expanded
        };
      });
    }
  }, {
    key: "handleKeyPress",
    value: function handleKeyPress(event) {
      if ((event.key === 'Enter' || event.key === ' ') && event.target.tagName === 'TR') {
        this.setState(function (prevState) {
          return {
            expanded: !prevState.expanded
          };
        });
        event.preventDefault();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          cells = _this$props.cells,
          columns = _this$props.columns,
          children = _this$props.children,
          rowRender = _this$props.rowRender,
          rowIndex = _this$props.rowIndex;
      var unexpandable = !children;
      return _react.default.createElement("tbody", null, _react.default.createElement(_TableRow.default, {
        cells: _objectSpread({}, cells, {
          expandIcon: unexpandable ? ' ' : _react.default.createElement(_chevronIkon.default, {
            className: (0, _classnames.default)('ffe-table__expand-icon', {
              'ffe-table__expand-icon--expanded': this.state.expanded
            })
          })
        }),
        trClasses: (0, _classnames.default)({
          'ffe-table__row-expandable': !unexpandable
        }, {
          'ffe-table__row-expandable--expanded': this.state.expanded
        }),
        columns: columns,
        onClick: this.toggleExpand,
        onKeyDown: this.handleKeyPress,
        expandable: !unexpandable,
        expanded: this.state.expanded,
        rowRender: rowRender,
        rowIndex: rowIndex
      }), _react.default.createElement("tr", {
        role: "presentation",
        "aria-hidden": String(!this.state.expanded),
        className: (0, _classnames.default)('ffe-table__row', 'ffe-table__row-expandable-content', {
          'ffe-table__row-expandable-content--expanded': this.state.expanded
        }, {
          'ffe-table__row--collapsed': !this.state.expanded
        })
      }, _react.default.createElement("td", {
        colSpan: columns.length,
        className: "ffe-table__cell-expandable-content"
      }, _react.default.createElement("div", null, this.state.expanded && children))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (!nextProps.children && prevState.expanded || !(0, _shallowEquals.default)(nextProps.sort, prevState.sort)) {
        return {
          expanded: false,
          sort: nextProps.sort
        };
      }

      return null;
    }
  }]);

  return TableRowExpandable;
}(_react.Component);

TableRowExpandable.propTypes = {
  children: _propTypes.default.node,
  cells: _propTypes.default.object.isRequired,
  columns: _propTypes.default.array.isRequired,
  sort: _propTypes.default.object,
  rowRender: _propTypes.default.func,
  headerRender: _propTypes.default.func,
  footerRender: _propTypes.default.func,
  rowIndex: _propTypes.default.number
};
(0, _reactLifecyclesCompat.polyfill)(TableRowExpandable);
var _default = TableRowExpandable;
exports.default = _default;